> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/forms/forms/create-combobox-field.md).

# Create Combobox Fields

Learn how to add combobox fields to your PDF using JavaScript with WebViewer. The Apryse Web SDK streamlines secure, serverless document processing with robust support for JavaScript and TypeScript, a

Combobox (choice) fields and widget annotations can be added programmatically. There are several properties and widget flags as highlighted below:

### Combobox widget flags

| Widget flag   | Description                                                              | Unique to combobox? |
| ------------- | ------------------------------------------------------------------------ | ------------------- |
| READ\_ONLY    | The field value cannot be changed.                                       | No                  |
| REQUIRED      | The field must have a value when exported.                               | No                  |
| COMBO         | The field is a combobox. Must be **true**.                               | No                  |
| MULTI\_SELECT | The field can have multiple selected values.                             | No                  |
| EDIT          | If true, the combobox will include an editable text box with a dropdown. | Yes                 |

### Combobox sample code

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
.then(instance => {
  const { annotationManager, Annotations, documentViewer } = instance.Core;
  const { WidgetFlags } = Annotations;

  documentViewer.addEventListener('documentLoaded', () => {
    // Sets flags for the combobox widget.
    const flags = new WidgetFlags();
    flags.set(WidgetFlags.COMBO, true);
    flags.set(WidgetFlags.REQUIRED, true);

    // Define the available options.
    const comboOptions = [
      { value: '1', displayValue: 'one' },
      { value: '2', displayValue: 'two' },
      { value: '3', displayValue: 'three' }
    ];

    // Specify a font-family and font size.
    const font = new Annotations.Font({ name: 'Helvetica', size: 12 });

    // Creates a combobox form field.
    const field = new Annotations.Forms.Field('ComboBoxField 1', {
      flags,
      font,
      type: 'Ch',
      options: comboOptions,
      value: comboOptions[0].value,
    });

    // Creates a combobox widget annotation.
    const widgetAnnot = new Annotations.ChoiceWidgetAnnotation(field);
    widgetAnnot.PageNumber = 1;
    widgetAnnot.X = 100;
    widgetAnnot.Y = 100;
    widgetAnnot.Width = 200;
    widgetAnnot.Height = 25;

    // Add form field to field manager and widget annotation to annotation manager.
    annotationManager.getFieldManager().addField(field);
    annotationManager.addAnnotation(widgetAnnot);
    annotationManager.drawAnnotationsFromList([widgetAnnot]);
  });
});
```

{% endcode %}

[Annotations.WidgetFlags](https://sdk.apryse.com/api/web/Core.Annotations.WidgetFlags.html) [Annotations.Forms.Field](https://sdk.apryse.com/api/web/Core.Annotations.Forms.Field.html) [Annotations.ChoiceWidgetAnnotation](https://sdk.apryse.com/api/web/Core.Annotations.ChoiceWidgetAnnotation.html#ChoiceWidgetAnnotation__anchor) [Annotations.WidgetAnnotation](https://sdk.apryse.com/api/web/Core.Annotations.WidgetAnnotation.html) [AnnotationManager.addAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#addAnnotation__anchor) [AnnotationManager.drawAnnotationsFromList](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#drawAnnotationsFromList__anchor) [AnnotationManager.getFieldManager](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#getFieldManager__anchor) [FieldManager.addField](https://sdk.apryse.com/api/web/Core.Annotations.Forms.FieldManager.html#addField__anchor)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { docViewer, annotManager, Annotations } = instance;

    docViewer.on('documentLoaded', () => {
      // create field and widget annotations here
    });
  });
```

{% endcode %}

[DocumentViewer#documentLoaded](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#event:documentLoaded__anchor)
{% endtab %}
{% endtabs %}

#### Learn More

Annotations and fields should be added to the document only after the document has finished loading. See [Create New Form Fields Overview](/web/forms/create-fields.md) for more.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/forms/forms/create-combobox-field.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
